package com.chinaitop.depot.intelligent.grainsituation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TActkindHistoryExample {
    /**
     * t_actkind_history
     */
    protected String orderByClause;

    /**
     * t_actkind_history
     */
    protected boolean distinct;

    /**
     * t_actkind_history
     */
    protected List<Criteria> oredCriteria;

    public TActkindHistoryExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_actkind_history 2018-11-06
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andVdevcodeIsNull() {
            addCriterion("vDevCode is null");
            return (Criteria) this;
        }

        public Criteria andVdevcodeIsNotNull() {
            addCriterion("vDevCode is not null");
            return (Criteria) this;
        }

        public Criteria andVdevcodeEqualTo(String value) {
            addCriterion("vDevCode =", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeNotEqualTo(String value) {
            addCriterion("vDevCode <>", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeGreaterThan(String value) {
            addCriterion("vDevCode >", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeGreaterThanOrEqualTo(String value) {
            addCriterion("vDevCode >=", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeLessThan(String value) {
            addCriterion("vDevCode <", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeLessThanOrEqualTo(String value) {
            addCriterion("vDevCode <=", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeLike(String value) {
            addCriterion("vDevCode like", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeNotLike(String value) {
            addCriterion("vDevCode not like", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeIn(List<String> values) {
            addCriterion("vDevCode in", values, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeNotIn(List<String> values) {
            addCriterion("vDevCode not in", values, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeBetween(String value1, String value2) {
            addCriterion("vDevCode between", value1, value2, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeNotBetween(String value1, String value2) {
            addCriterion("vDevCode not between", value1, value2, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andFvalueIsNull() {
            addCriterion("fValue is null");
            return (Criteria) this;
        }

        public Criteria andFvalueIsNotNull() {
            addCriterion("fValue is not null");
            return (Criteria) this;
        }

        public Criteria andFvalueEqualTo(BigDecimal value) {
            addCriterion("fValue =", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueNotEqualTo(BigDecimal value) {
            addCriterion("fValue <>", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueGreaterThan(BigDecimal value) {
            addCriterion("fValue >", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("fValue >=", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueLessThan(BigDecimal value) {
            addCriterion("fValue <", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("fValue <=", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueIn(List<BigDecimal> values) {
            addCriterion("fValue in", values, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueNotIn(List<BigDecimal> values) {
            addCriterion("fValue not in", values, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fValue between", value1, value2, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fValue not between", value1, value2, "fvalue");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeIsNull() {
            addCriterion("vUpdatetime is null");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeIsNotNull() {
            addCriterion("vUpdatetime is not null");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeEqualTo(Date value) {
            addCriterion("vUpdatetime =", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeNotEqualTo(Date value) {
            addCriterion("vUpdatetime <>", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeGreaterThan(Date value) {
            addCriterion("vUpdatetime >", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeGreaterThanOrEqualTo(Date value) {
            addCriterion("vUpdatetime >=", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeLessThan(Date value) {
            addCriterion("vUpdatetime <", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeLessThanOrEqualTo(Date value) {
            addCriterion("vUpdatetime <=", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeIn(List<Date> values) {
            addCriterion("vUpdatetime in", values, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeNotIn(List<Date> values) {
            addCriterion("vUpdatetime not in", values, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeBetween(Date value1, Date value2) {
            addCriterion("vUpdatetime between", value1, value2, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeNotBetween(Date value1, Date value2) {
            addCriterion("vUpdatetime not between", value1, value2, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVremarkIsNull() {
            addCriterion("vRemark is null");
            return (Criteria) this;
        }

        public Criteria andVremarkIsNotNull() {
            addCriterion("vRemark is not null");
            return (Criteria) this;
        }

        public Criteria andVremarkEqualTo(String value) {
            addCriterion("vRemark =", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotEqualTo(String value) {
            addCriterion("vRemark <>", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkGreaterThan(String value) {
            addCriterion("vRemark >", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkGreaterThanOrEqualTo(String value) {
            addCriterion("vRemark >=", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLessThan(String value) {
            addCriterion("vRemark <", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLessThanOrEqualTo(String value) {
            addCriterion("vRemark <=", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLike(String value) {
            addCriterion("vRemark like", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotLike(String value) {
            addCriterion("vRemark not like", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkIn(List<String> values) {
            addCriterion("vRemark in", values, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotIn(List<String> values) {
            addCriterion("vRemark not in", values, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkBetween(String value1, String value2) {
            addCriterion("vRemark between", value1, value2, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotBetween(String value1, String value2) {
            addCriterion("vRemark not between", value1, value2, "vremark");
            return (Criteria) this;
        }
    }

    /**
     * t_actkind_history
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_actkind_history 2018-11-06
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}